import "package:flutter/material.dart";

// Originally generated by https://material-foundation.github.io/material-theme-builder/
// from a source color of #5D23DD

class MaterialTheme {
  final TextTheme textTheme;

  const MaterialTheme(this.textTheme);

  static ColorScheme lightScheme() {
    return const ColorScheme(
      brightness: Brightness.light,
      primary: Color(4284700303),
      surfaceTint: Color(4284700303),
      onPrimary: Color(4294967295),
      primaryContainer: Color(4293451519),
      onPrimaryContainer: Color(4283121270),
      secondary: Color(4284570481),
      onSecondary: Color(4294967295),
      secondaryContainer: Color(4293385976),
      onSecondaryContainer: Color(4282991704),
      tertiary: Color(4286403169),
      onTertiary: Color(4294967295),
      tertiaryContainer: Color(4294957540),
      onTertiaryContainer: Color(4284693322),
      error: Color(4290386458),
      onError: Color(4294967295),
      errorContainer: Color(4294957782),
      onErrorContainer: Color(4287823882),
      surface: Color(4294834175),
      onSurface: Color(4280032032),
      onSurfaceVariant: Color(4282926414),
      outline: Color(4286150015),
      outlineVariant: Color(4291478735),
      shadow: Color(4278190080),
      scrim: Color(4278190080),
      inverseSurface: Color(4281478965),
      inversePrimary: Color(4291673599),
      primaryFixed: Color(4293451519),
      onPrimaryFixed: Color(4280225864),
      primaryFixedDim: Color(4291673599),
      onPrimaryFixedVariant: Color(4283121270),
      secondaryFixed: Color(4293385976),
      onSecondaryFixed: Color(4280097067),
      secondaryFixedDim: Color(4291544028),
      onSecondaryFixedVariant: Color(4282991704),
      tertiaryFixed: Color(4294957540),
      onTertiaryFixed: Color(4281405726),
      tertiaryFixedDim: Color(4293834953),
      onTertiaryFixedVariant: Color(4284693322),
      surfaceDim: Color(4292729056),
      surfaceBright: Color(4294834175),
      surfaceContainerLowest: Color(4294967295),
      surfaceContainerLow: Color(4294439674),
      surfaceContainer: Color(4294110452),
      surfaceContainerHigh: Color(4293715694),
      surfaceContainerHighest: Color(4293321193),
    );
  }

  ThemeData light() {
    return theme(lightScheme());
  }

  static ColorScheme lightMediumContrastScheme() {
    return const ColorScheme(
      brightness: Brightness.light,
      primary: Color(4282002788),
      surfaceTint: Color(4284700303),
      onPrimary: Color(4294967295),
      primaryContainer: Color(4285686943),
      onPrimaryContainer: Color(4294967295),
      secondary: Color(4281873223),
      onSecondary: Color(4294967295),
      secondaryContainer: Color(4285557376),
      onSecondaryContainer: Color(4294967295),
      tertiary: Color(4283444025),
      onTertiary: Color(4294967295),
      tertiaryContainer: Color(4287455344),
      onTertiaryContainer: Color(4294967295),
      error: Color(4285792262),
      onError: Color(4294967295),
      errorContainer: Color(4291767335),
      onErrorContainer: Color(4294967295),
      surface: Color(4294834175),
      onSurface: Color(4279373846),
      onSurfaceVariant: Color(4281873725),
      outline: Color(4283715930),
      outlineVariant: Color(4285492085),
      shadow: Color(4278190080),
      scrim: Color(4278190080),
      inverseSurface: Color(4281478965),
      inversePrimary: Color(4291673599),
      primaryFixed: Color(4285686943),
      onPrimaryFixed: Color(4294967295),
      primaryFixedDim: Color(4284042373),
      onPrimaryFixedVariant: Color(4294967295),
      secondaryFixed: Color(4285557376),
      onSecondaryFixed: Color(4294967295),
      secondaryFixedDim: Color(4283912807),
      onSecondaryFixedVariant: Color(4294967295),
      tertiaryFixed: Color(4287455344),
      onTertiaryFixed: Color(4294967295),
      tertiaryFixedDim: Color(4285679960),
      onTertiaryFixedVariant: Color(4294967295),
      surfaceDim: Color(4291478989),
      surfaceBright: Color(4294834175),
      surfaceContainerLowest: Color(4294967295),
      surfaceContainerLow: Color(4294439674),
      surfaceContainer: Color(4293715694),
      surfaceContainerHigh: Color(4292926435),
      surfaceContainerHighest: Color(4292202712),
    );
  }

  ThemeData lightMediumContrast() {
    return theme(lightMediumContrastScheme());
  }

  static ColorScheme lightHighContrastScheme() {
    return const ColorScheme(
      brightness: Brightness.light,
      primary: Color(4281344857),
      surfaceTint: Color(4284700303),
      onPrimary: Color(4294967295),
      primaryContainer: Color(4283252856),
      onPrimaryContainer: Color(4294967295),
      secondary: Color(4281215292),
      onSecondary: Color(4294967295),
      secondaryContainer: Color(4283123291),
      onSecondaryContainer: Color(4294967295),
      tertiary: Color(4282655023),
      onTertiary: Color(4294967295),
      tertiaryContainer: Color(4284824908),
      onTertiaryContainer: Color(4294967295),
      error: Color(4284481540),
      onError: Color(4294967295),
      errorContainer: Color(4288151562),
      onErrorContainer: Color(4294967295),
      surface: Color(4294834175),
      onSurface: Color(4278190080),
      onSurfaceVariant: Color(4278190080),
      outline: Color(4281150259),
      outlineVariant: Color(4283123793),
      shadow: Color(4278190080),
      scrim: Color(4278190080),
      inverseSurface: Color(4281478965),
      inversePrimary: Color(4291673599),
      primaryFixed: Color(4283252856),
      onPrimaryFixed: Color(4294967295),
      primaryFixedDim: Color(4281739616),
      onPrimaryFixedVariant: Color(4294967295),
      secondaryFixed: Color(4283123291),
      onSecondaryFixed: Color(4294967295),
      secondaryFixedDim: Color(4281675843),
      onSecondaryFixedVariant: Color(4294967295),
      tertiaryFixed: Color(4284824908),
      onTertiaryFixed: Color(4294967295),
      tertiaryFixedDim: Color(4283180853),
      onTertiaryFixedVariant: Color(4294967295),
      surfaceDim: Color(4290557887),
      surfaceBright: Color(4294834175),
      surfaceContainerLowest: Color(4294967295),
      surfaceContainerLow: Color(4294242295),
      surfaceContainer: Color(4293321193),
      surfaceContainerHigh: Color(4292400090),
      surfaceContainerHighest: Color(4291478989),
    );
  }

  ThemeData lightHighContrast() {
    return theme(lightHighContrastScheme());
  }

  static ColorScheme darkScheme() {
    return const ColorScheme(
      brightness: Brightness.dark,
      primary: Color(4291673599),
      surfaceTint: Color(4291673599),
      onPrimary: Color(4281608030),
      primaryContainer: Color(4283121270),
      onPrimaryContainer: Color(4293451519),
      secondary: Color(4291544028),
      onSecondary: Color(4281478721),
      secondaryContainer: Color(4282991704),
      onSecondaryContainer: Color(4293385976),
      tertiary: Color(4293834953),
      onTertiary: Color(4282983731),
      tertiaryContainer: Color(4284693322),
      onTertiaryContainer: Color(4294957540),
      error: Color(4294948011),
      onError: Color(4285071365),
      errorContainer: Color(4287823882),
      onErrorContainer: Color(4294957782),
      surface: Color(4279505688),
      onSurface: Color(4293321193),
      onSurfaceVariant: Color(4291478735),
      outline: Color(4287860633),
      outlineVariant: Color(4282926414),
      shadow: Color(4278190080),
      scrim: Color(4278190080),
      inverseSurface: Color(4293321193),
      inversePrimary: Color(4284700303),
      primaryFixed: Color(4293451519),
      onPrimaryFixed: Color(4280225864),
      primaryFixedDim: Color(4291673599),
      onPrimaryFixedVariant: Color(4283121270),
      secondaryFixed: Color(4293385976),
      onSecondaryFixed: Color(4280097067),
      secondaryFixedDim: Color(4291544028),
      onSecondaryFixedVariant: Color(4282991704),
      tertiaryFixed: Color(4294957540),
      onTertiaryFixed: Color(4281405726),
      tertiaryFixedDim: Color(4293834953),
      onTertiaryFixedVariant: Color(4284693322),
      surfaceDim: Color(4279505688),
      surfaceBright: Color(4282005566),
      surfaceContainerLowest: Color(4279176467),
      surfaceContainerLow: Color(4280032032),
      surfaceContainer: Color(4280295204),
      surfaceContainerHigh: Color(4281018671),
      surfaceContainerHighest: Color(4281742394),
    );
  }

  ThemeData dark() {
    return theme(darkScheme());
  }

  static ColorScheme darkMediumContrastScheme() {
    return const ColorScheme(
      brightness: Brightness.dark,
      primary: Color(4293056255),
      surfaceTint: Color(4291673599),
      onPrimary: Color(4280884306),
      primaryContainer: Color(4288055493),
      onPrimaryContainer: Color(4278190080),
      secondary: Color(4292991218),
      onSecondary: Color(4280754998),
      secondaryContainer: Color(4287925669),
      onSecondaryContainer: Color(4278190080),
      tertiary: Color(4294955230),
      onTertiary: Color(4282194472),
      tertiaryContainer: Color(4290020244),
      onTertiaryContainer: Color(4278190080),
      error: Color(4294955724),
      onError: Color(4283695107),
      errorContainer: Color(4294923337),
      onErrorContainer: Color(4278190080),
      surface: Color(4279505688),
      onSurface: Color(4294967295),
      onSurfaceVariant: Color(4292926181),
      outline: Color(4290097339),
      outlineVariant: Color(4287860377),
      shadow: Color(4278190080),
      scrim: Color(4278190080),
      inverseSurface: Color(4293321193),
      inversePrimary: Color(4283187063),
      primaryFixed: Color(4293451519),
      onPrimaryFixed: Color(4279501629),
      primaryFixedDim: Color(4291673599),
      onPrimaryFixedVariant: Color(4282002788),
      secondaryFixed: Color(4293385976),
      onSecondaryFixed: Color(4279438880),
      secondaryFixedDim: Color(4291544028),
      onSecondaryFixedVariant: Color(4281873223),
      tertiaryFixed: Color(4294957540),
      onTertiaryFixed: Color(4280550932),
      tertiaryFixedDim: Color(4293834953),
      onTertiaryFixedVariant: Color(4283444025),
      surfaceDim: Color(4279505688),
      surfaceBright: Color(4282794826),
      surfaceContainerLowest: Color(4278716172),
      surfaceContainerLow: Color(4280163618),
      surfaceContainer: Color(4280887085),
      surfaceContainerHigh: Color(4281610808),
      surfaceContainerHighest: Color(4282334531),
    );
  }

  ThemeData darkMediumContrast() {
    return theme(darkMediumContrastScheme());
  }

  static ColorScheme darkHighContrastScheme() {
    return const ColorScheme(
      brightness: Brightness.dark,
      primary: Color(4294241791),
      surfaceTint: Color(4291673599),
      onPrimary: Color(4278190080),
      primaryContainer: Color(4291410427),
      onPrimaryContainer: Color(4279107636),
      secondary: Color(4294241791),
      onSecondary: Color(4278190080),
      secondaryContainer: Color(4291280856),
      onSecondaryContainer: Color(4279044122),
      tertiary: Color(4294962160),
      onTertiary: Color(4278190080),
      tertiaryContainer: Color(4293571782),
      onTertiaryContainer: Color(4280091150),
      error: Color(4294962409),
      onError: Color(4278190080),
      errorContainer: Color(4294946468),
      onErrorContainer: Color(4280418305),
      surface: Color(4279505688),
      onSurface: Color(4294967295),
      onSurfaceVariant: Color(4294967295),
      outline: Color(4294242041),
      outlineVariant: Color(4291215563),
      shadow: Color(4278190080),
      scrim: Color(4278190080),
      inverseSurface: Color(4293321193),
      inversePrimary: Color(4283187063),
      primaryFixed: Color(4293451519),
      onPrimaryFixed: Color(4278190080),
      primaryFixedDim: Color(4291673599),
      onPrimaryFixedVariant: Color(4279501629),
      secondaryFixed: Color(4293385976),
      onSecondaryFixed: Color(4278190080),
      secondaryFixedDim: Color(4291544028),
      onSecondaryFixedVariant: Color(4279438880),
      tertiaryFixed: Color(4294957540),
      onTertiaryFixed: Color(4278190080),
      tertiaryFixedDim: Color(4293834953),
      onTertiaryFixedVariant: Color(4280550932),
      surfaceDim: Color(4279505688),
      surfaceBright: Color(4283584341),
      surfaceContainerLowest: Color(4278190080),
      surfaceContainerLow: Color(4280295204),
      surfaceContainer: Color(4281478965),
      surfaceContainerHigh: Color(4282202689),
      surfaceContainerHighest: Color(4282926668),
    );
  }

  ThemeData darkHighContrast() {
    return theme(darkHighContrastScheme());
  }

  ThemeData theme(ColorScheme colorScheme) => ThemeData(
    useMaterial3: true,
    brightness: colorScheme.brightness,
    colorScheme: colorScheme,
    textTheme: textTheme.apply(bodyColor: colorScheme.onSurface, displayColor: colorScheme.onSurface),
    scaffoldBackgroundColor: colorScheme.surface,
    canvasColor: colorScheme.surface,
    pageTransitionsTheme: PageTransitionsTheme(
      builders: Map<TargetPlatform, PageTransitionsBuilder>.fromIterable(
        TargetPlatform.values,
        value: (_) => const FadeForwardsPageTransitionsBuilder(),
      ),
    ),
  );

  List<ExtendedColor> get extendedColors => [];
}

class ExtendedColor {
  final Color seed, value;
  final ColorFamily light;
  final ColorFamily lightHighContrast;
  final ColorFamily lightMediumContrast;
  final ColorFamily dark;
  final ColorFamily darkHighContrast;
  final ColorFamily darkMediumContrast;

  const ExtendedColor({
    required this.seed,
    required this.value,
    required this.light,
    required this.lightHighContrast,
    required this.lightMediumContrast,
    required this.dark,
    required this.darkHighContrast,
    required this.darkMediumContrast,
  });
}

class ColorFamily {
  const ColorFamily({
    required this.color,
    required this.onColor,
    required this.colorContainer,
    required this.onColorContainer,
  });

  final Color color;
  final Color onColor;
  final Color colorContainer;
  final Color onColorContainer;
}
